/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package libconnect.core;

import java.io.ByteArrayInputStream;
import java.util.Formatter;

/**
 *
 * @author luke
 */
public class HabboPacket extends ByteArrayInputStream {
    
    public byte[] dat;
    String header;
    
    public HabboPacket(byte[] data){
        super(data);
        dat = data;
        header = new String(data, 0, 2);
        skip(2);
    }
    
    public String getHeader(){
        return header;
    }
    
    public byte[] getBytes(){
        return dat;
    }
    
    public String toBinaryString(){
        StringBuilder builder = new StringBuilder();
        for(byte b : dat){
            char c = (char) b;
            if(c >= 0x10 && c <= 0x80 &&  c != '[' &&  c != ']') {
                builder.append(c);
            } else {
                builder.append("[");
                builder.append(Integer.toHexString(c));
                builder.append("]");
            }
        }
        return builder.toString();
    }
    
    public String readString(){
        StringBuilder b = new StringBuilder();
        int r;
        while((r = read()) > -1){
            if(r == 2) break;
            b.append((char) r);
        }
        return b.toString();
    }
    
    public int readVL64(int len){
        StringBuilder b = new StringBuilder();
        int r;
        while((r = read()) > -1){
            if(len <= 0) break;
            b.append((char) r);
            len--;
        }
        return VL64.decode(b.toString().toCharArray());
    }
    
    public int readVL64(){
        return VL64.decode(readString().toCharArray());
    }
    
//    static {
//        System.out.println("@A: "+(DecodeVL64("@A".toCharArray())));
//        System.exit(0);
//    }
    
    
//    public static class Encoding
//    {
//        #region Base64
//        public static string encodeB64(int value, int length)
//        {
//            string stack = "";
//            for (int x = 1; x <= length; x++)
//            {
//                int offset = 6 * (length - x);
//                byte val = (byte)(64 + (value >> offset & 0x3f));
//                stack += (char)val;
//            }
//            return stack;
//        }
//        public static string encodeB64(string Val)
//        {
//            int value = Val.Length;
//            int length = 2;
//            string stack = "";
//            for (int x = 1; x <= length; x++)
//            {
//                int offset = 6 * (length - x);
//                byte val = (byte)(64 + (value >> offset & 0x3f));
//                stack += (char)val;
//            }
//            return stack;
//        }
//        public static int decodeB64(string Val)
//        {
//            char[] val = Val.ToCharArray();
//            int intTot = 0;
//            int y = 0;
//            for (int x = (val.Length - 1); x >= 0; x--)
//            {
//                int intTmp = (int)(byte)((val[x] - 64));
//                if (y > 0)
//                {
//                    intTmp = intTmp * (int)(Math.Pow(64, y));
//                }
//                intTot += intTmp;
//                y++;
//            }
//            return intTot;
//        }
//        #endregion
//        #region VL64
//        public static string encodeVL64(int i)
//        {
//            byte[] wf = new byte[6];
//            int pos = 0;
//            int startPos = pos;
//            int bytes = 1;
//            int negativeMask = i >= 0 ? 0 : 4;
//            i = Math.Abs(i);
//            wf[pos++] = (byte)(64 + (i & 3));
//            for (i >>= 2; i != 0; i >>= 6)
//            {
//                bytes++;
//                wf[pos++] = (byte)(64 + (i & 0x3f));
//            }
//
//            wf[startPos] = (byte)(wf[startPos] | bytes << 3 | negativeMask);
//
//            System.Text.ASCIIEncoding encoder = new ASCIIEncoding();
//            string tmp = encoder.GetString(wf);
//            return tmp.Replace("\0", "");
//        }
//        public static int decodeVL64(string data)
//        {
//            return decodeVL64(data.ToCharArray());
//        }
//        public static int decodeVL64(char[] raw)
//        {
//            try
//            {
//                int pos = 0;
//                int v = 0;
//                bool negative = (raw[pos] & 4) == 4;
//                int totalBytes = raw[pos] >> 3 & 7;
//                v = raw[pos] & 3;
//                pos++;
//                int shiftAmount = 2;
//                for (int b = 1; b < totalBytes; b++)
//                {
//                    v |= (raw[pos] & 0x3f) << shiftAmount;
//                    shiftAmount = 2 + 6 * b;
//                    pos++;
//                }
//
//                if (negative)
//                    v *= -1;
//
//                return v;
//            }
//            catch
//            {
//                return 0;
//            }
//        }
//        #endregion
//    }
//}

}
